VERSION 5.00
Begin VB.Form FRsTest 
   Caption         =   "Test Form"
   ClientHeight    =   3675
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3675
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdFieldValues 
      Caption         =   "FIELD VALUES (e.g. sField1 = fldFirst.Value)"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   3120
      Width           =   4395
   End
   Begin VB.CommandButton cmdFields 
      Caption         =   "FIELD OBJECTS (e.g. sField1 = fldFirst)"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   2580
      Width           =   4395
   End
   Begin VB.CommandButton cmdID 
      Caption         =   "ID (e.g. sField1 = .Fields(1))"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   2040
      Width           =   4395
   End
   Begin VB.CommandButton cmdName 
      Caption         =   "NAME (e.g. sField1 = .Fields(""FirstName""))"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1500
      Width           =   4395
   End
   Begin VB.CommandButton cmdBang 
      Caption         =   "BANG (e.g. sField1 = m_rsMain!FirstName)"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   960
      Width           =   4395
   End
   Begin VB.Label Label1 
      Caption         =   "These buttons test the various methods of refering to database field values for speed by looping through 10000 records."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   60
      TabIndex        =   4
      Top             =   60
      Width           =   4515
   End
End
Attribute VB_Name = "FRsTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*******************************************************************************
' MODULE:       Form1
' AUTHOR:       Phil Fresle
' CREATED:      22-May-2000
' COPYRIGHT:    Copyright 2000 Frez Systems Limited
'
' DESCRIPTION:
' Form to test the various methods of referencing recordset field values that
' demonstrates the difference in performance.
'
' MODIFICATION HISTORY:
' 1.0       28-Jun-2000
'           Phil Fresle
'           Initial Version
'*******************************************************************************
Option Explicit

Private Declare Function QueryPerformanceCounter Lib "kernel32" _
    (lpPerformanceCount As Currency) As Long
    
Private Declare Function QueryPerformanceFrequency Lib "kernel32" _
    (lpFrequency As Currency) As Long

Private Enum MyFields
    FirstNameField = 0
    MiddleNameField
    LastNameField
End Enum

Private m_rsMain As ADODB.Recordset

Private Const MAX_NUM As Long = 10000

'*******************************************************************************
' cmdBang_Click (SUB)
'
' DESCRIPTION:
' Demonstrates referencing the values by using the bang operator.
'
' PARAMETERS:
' None
'*******************************************************************************
Private Sub cmdBang_Click()
    Dim sField1     As String
    Dim sField2     As String
    Dim sField3     As String
    Dim lCount      As Long
    Dim cFrequency  As Currency
    Dim cOverhead   As Currency
    Dim cCounter1   As Currency
    Dim cCounter2   As Currency
    Dim cElapsed    As Currency
    
    m_rsMain.MoveFirst
    
    QueryPerformanceFrequency cFrequency
    QueryPerformanceCounter cCounter1
    QueryPerformanceCounter cCounter2
    cOverhead = cCounter2 - cCounter1
    
    QueryPerformanceCounter cCounter1
    
    For lCount = 1 To MAX_NUM
        sField1 = m_rsMain!FirstName
        sField2 = m_rsMain!MiddleName
        sField3 = m_rsMain!LastName
        m_rsMain.MoveNext
    Next
    
    QueryPerformanceCounter cCounter2
    cElapsed = (cCounter2 - cCounter1 - cOverhead) / cFrequency
    
    MsgBox "Processed in " & Format(cElapsed, "0.0000") & " seconds"
End Sub


'*******************************************************************************
' cmdFields_Click (SUB)
'
' DESCRIPTION:
' Demonstrates referencing the values by assigning field objects before the loop
' begins. This would only be quicker where you were looping through a number of
' records due to the overhead of assigning the field objects. If not looping use
' the ID method. Almost identical to cmdFieldValues_Click except the Value
' property is obtained by default.
'*******************************************************************************
Private Sub cmdFields_Click()
    Dim sField1     As String
    Dim sField2     As String
    Dim sField3     As String
    
    Dim fldFirst    As ADODB.Field
    Dim fldMiddle   As ADODB.Field
    Dim fldLast     As ADODB.Field
    
    Dim lCount      As Long
    
    Dim cFrequency  As Currency
    Dim cOverhead   As Currency
    Dim cCounter1   As Currency
    Dim cCounter2   As Currency
    Dim cElapsed    As Currency
    
    m_rsMain.MoveFirst
    
    QueryPerformanceFrequency cFrequency
    QueryPerformanceCounter cCounter1
    QueryPerformanceCounter cCounter2
    cOverhead = cCounter2 - cCounter1
    
    QueryPerformanceCounter cCounter1
    
    Set fldFirst = m_rsMain.Fields(FirstNameField)
    Set fldMiddle = m_rsMain.Fields(MiddleNameField)
    Set fldLast = m_rsMain.Fields(LastNameField)
    For lCount = 1 To MAX_NUM
        sField1 = fldFirst
        sField2 = fldMiddle
        sField3 = fldLast
        m_rsMain.MoveNext
    Next
    Set fldFirst = Nothing
    Set fldMiddle = Nothing
    Set fldLast = Nothing
    
    QueryPerformanceCounter cCounter2
    cElapsed = (cCounter2 - cCounter1 - cOverhead) / cFrequency
    
    MsgBox "Processed in " & Format(cElapsed, "0.0000") & " seconds"
End Sub

'*******************************************************************************
' cmdFieldValues_Click (SUB)
'
' DESCRIPTION:
' Demonstrates referencing the values by assigning field objects before the loop
' begins. This would only be quicker where you were looping through a number of
' records due to the overhead of assigning the field objects. If not looping use
' the ID method. Almost identical to cmdFields_Click except the Value property
' is explicitly set.
'*******************************************************************************
Private Sub cmdFieldValues_Click()
    Dim sField1     As String
    Dim sField2     As String
    Dim sField3     As String
    
    Dim fldFirst    As ADODB.Field
    Dim fldMiddle   As ADODB.Field
    Dim fldLast     As ADODB.Field
    
    Dim lCount      As Long
    
    Dim cFrequency  As Currency
    Dim cOverhead   As Currency
    Dim cCounter1   As Currency
    Dim cCounter2   As Currency
    Dim cElapsed    As Currency
    
    m_rsMain.MoveFirst
    
    QueryPerformanceFrequency cFrequency
    QueryPerformanceCounter cCounter1
    QueryPerformanceCounter cCounter2
    cOverhead = cCounter2 - cCounter1
    
    QueryPerformanceCounter cCounter1
    
    Set fldFirst = m_rsMain.Fields(FirstNameField)
    Set fldMiddle = m_rsMain.Fields(MiddleNameField)
    Set fldLast = m_rsMain.Fields(LastNameField)
    For lCount = 1 To MAX_NUM
        sField1 = fldFirst.Value
        sField2 = fldMiddle.Value
        sField3 = fldLast.Value
        m_rsMain.MoveNext
    Next
    Set fldFirst = Nothing
    Set fldMiddle = Nothing
    Set fldLast = Nothing
    
    QueryPerformanceCounter cCounter2
    cElapsed = (cCounter2 - cCounter1 - cOverhead) / cFrequency
    
    MsgBox "Processed in " & Format(cElapsed, "0.0000") & " seconds"
End Sub

'*******************************************************************************
' cmdID_Click (SUB)
'
' DESCRIPTION:
' Demonstrates referencing the values by using the field ID.
'*******************************************************************************
Private Sub cmdID_Click()
    Dim sField1     As String
    Dim sField2     As String
    Dim sField3     As String
    Dim lCount      As Long
    Dim cFrequency  As Currency
    Dim cOverhead   As Currency
    Dim cCounter1   As Currency
    Dim cCounter2   As Currency
    Dim cElapsed    As Currency
    
    m_rsMain.MoveFirst
    
    QueryPerformanceFrequency cFrequency
    QueryPerformanceCounter cCounter1
    QueryPerformanceCounter cCounter2
    cOverhead = cCounter2 - cCounter1
    
    QueryPerformanceCounter cCounter1
    
    With m_rsMain
        For lCount = 1 To MAX_NUM
            sField1 = .Fields(FirstNameField)
            sField2 = .Fields(MiddleNameField)
            sField3 = .Fields(LastNameField)
            .MoveNext
        Next
    End With
    
    QueryPerformanceCounter cCounter2
    cElapsed = (cCounter2 - cCounter1 - cOverhead) / cFrequency
    
    MsgBox "Processed in " & Format(cElapsed, "0.0000") & " seconds"
End Sub

'*******************************************************************************
' cmdName_Click (SUB)
'
' DESCRIPTION:
' Demonstrates referencing the values by using the field name, similar in
' performance to the Bang method as VB has to do a lookup of the field name.
'*******************************************************************************
Private Sub cmdName_Click()
    Dim sField1     As String
    Dim sField2     As String
    Dim sField3     As String
    Dim lCount      As Long
    Dim cFrequency  As Currency
    Dim cOverhead   As Currency
    Dim cCounter1   As Currency
    Dim cCounter2   As Currency
    Dim cElapsed    As Currency
    
    m_rsMain.MoveFirst
    
    QueryPerformanceFrequency cFrequency
    QueryPerformanceCounter cCounter1
    QueryPerformanceCounter cCounter2
    cOverhead = cCounter2 - cCounter1
    
    QueryPerformanceCounter cCounter1
    
    With m_rsMain
        For lCount = 1 To MAX_NUM
            sField1 = .Fields("FirstName")
            sField2 = .Fields("MiddleName")
            sField3 = .Fields("LastName")
            .MoveNext
        Next
    End With
    
    QueryPerformanceCounter cCounter2
    cElapsed = (cCounter2 - cCounter1 - cOverhead) / cFrequency
    
    MsgBox "Processed in " & Format(cElapsed, "0.0000") & " seconds"
End Sub

'*******************************************************************************
' Form_Load (SUB)
'
' DESCRIPTION:
' As the form loads, create a recordset and load it with MAX_NUM records.
'*******************************************************************************
Private Sub Form_Load()
    Dim lCount As Long
    
    Set m_rsMain = New ADODB.Recordset
    
    m_rsMain.CursorLocation = adUseClient
    
    m_rsMain.Fields.Append "FirstName", adVarChar, 20
    m_rsMain.Fields.Append "MiddleName", adVarChar, 20
    m_rsMain.Fields.Append "LastName", adVarChar, 20
    
    m_rsMain.Open , , adOpenStatic, adLockBatchOptimistic
    
    For lCount = 1 To MAX_NUM
        m_rsMain.AddNew Array("FirstName", "MiddleName", "LastName"), _
            Array(CStr(lCount), CStr(lCount + 100000), CStr(lCount + 1000000))
    Next
End Sub

'*******************************************************************************
' Form_Unload (SUB)
'*******************************************************************************
Private Sub Form_Unload(Cancel As Integer)
    m_rsMain.Close
    Set m_rsMain = Nothing
End Sub
